module events
open util/ordering[Time] as time

sig Time {}
abstract sig Event {
	pre, post: Time
	}

fact Traces {
	all t: Time - last | some e: Event | e.pre = t and e.post = t.next
	all t: Time - last | lone e: Event | e.pre = t
	}

pred Event.unchanged (field: univ -> Time) {
	field.(this.pre) = field.(this.post)
	}

pred Event.unchanged (field: univ -> univ -> Time) {
	field.(this.pre) = field.(this.post)
	}

pred Event.changed (field: univ -> Time) {
	! this.unchanged [field]
	}

pred Event.changed (field: univ -> univ -> Time) {
	! this.unchanged [field]
	}

pred modifies (es: set Event, field: univ -> Time) {
	all e: Event -es | field.(e.pre) = field.(e.post)
	}

pred happensAt (es: set Event, t: Time) {
	t  in es.pre
	}

pred follows (after, before: Event) {
	after.pre in before.pre.*next
	}

pred at (field: set Time, t: Time) {
	t in field
	}

pred Event.before (field: set Time) {
	this.pre in field
	}
pred Event.after (field: set Time) {
	this.post in field
	}
pred before (field: set Time, e: Event) {
	e.pre in field
	}
pred initially (field: set Time) {
	first in field
	}
